<?xml version="1.0"?>
<odoo>
    <!-- We add some research, filter and group by function -->
    <record model="ir.ui.view" id="agepoly_mis_budget_by_account_item_search_view">
        <field name="name">
            mis.budget.by.account.item.search (in mis_builder_budget)
        </field>
        <field name="model">mis.budget.by.account.item</field>
        <field name="inherit_id" ref="mis_builder_budget.mis_budget_by_account_item_search_view"/>
        <field name="arch" type="xml">
            <xpath expr="//field[@name='account_id']" position="after">
                <field name="analytic_account_id"/>
                <field name="analytic_account_group_id"/>
                <field name="analytic_account_parent_group_id"/>
                <field name="analytic_tag_ids"/>
                <field name="name"/>
                <field name="date_range_id"/>

                 <filter string="Date" name="date" date="date"/>
                <separator/>
                <filter string="Current accounting year" name="current_year_agepoly" domain="['&amp;',('date_from','&gt;=',(context_today() - relativedelta(months=7)).strftime('%Y-08-01')),('date_to','&lt;=',(context_today() + relativedelta(months=5)).strftime('%Y-07-31'))]"/>
                <filter string="Previous accounting year" name="previous_year_agepoly" domain="['&amp;',('date_from','&gt;=',(context_today() - relativedelta(months=7, years=1)).strftime('%Y-08-01')),('date_to','&lt;=',(context_today() + relativedelta(months=5, years=-1)).strftime('%Y-07-31'))]"/>
                <filter string="-2 previous accounting year" name="two_past_year_agepoly" domain="['&amp;',('date_from','&gt;=',(context_today() - relativedelta(months=31, years=2)).strftime('%Y-08-01')),('date_to','&lt;=',(context_today() + relativedelta(months=5, years=-2)).strftime('%Y-07-31'))]"/>

                <group expand="0" string="Group By">
                    <filter string="Account" name="group_by_account" domain="[]" context="{'group_by': 'account_id'}"/>
                    <separator/>
                    <filter string="Date range" name="group_by_date_range" domain="[]" context="{'group_by': 'date_range_id'}"/>
                    <separator/>
                    <filter string="Analytic Group (Parent)" name="group_by_analytic_parent_group" domain="[]" context="{'group_by': 'analytic_account_parent_group_id'}"/>
                    <filter string="Analytic Group" name="group_by_analytic_group" domain="[]" context="{'group_by': 'analytic_account_group_id'}"/>
                    <filter string="Analytic Account" name="group_by_analytic_account" domain="[]" context="{'group_by': 'analytic_account_id'}"/>  
                </group>
            </xpath>  
        </field>
    </record>
    <!-- We add a pivot view -->
    <record model="ir.ui.view" id="agepoly_mis_budget_by_account_item_pivot_view">
        <field name="name">
            agepoly.mis.budget.by.account.item.pivot (in mis_builder_budget)
        </field>
        <field name="model">mis.budget.by.account.item</field>
        <field name="arch" type="xml">
            <pivot string="My Budget pivot">
                <field name="date_range_id" type="col"/>
                <field name="analytic_account_parent_group_id" type="row"/>
                <field name="analytic_account_group_id" type="row"/>
                <field name="analytic_account_id" type="row"/>
                <field name="inverse_balance" type="measure" widget="monetary"/>
            </pivot>
        </field>
    </record>   
    <!-- We add a graph view -->
    <record model="ir.ui.view" id="agepoly_mis_budget_by_account_item_graph_view">
        <field name="name">
            agepoly.mis.budget.by.account.item.graph (in mis_builder_budget)
        </field>
        <field name="model">mis.budget.by.account.item</field>
        <field name="arch" type="xml">
            <graph string="My Budget graph">
                <field name="date_range_id" type="col"/>
                <field name="analytic_account_parent_group_id" type="row"/>
                <field name="analytic_account_group_id" type="row"/>
                <field name="analytic_account_id" type="row"/>
                <field name="inverse_balance" type="measure"/>
            </graph>
        </field>
    </record>
    <!-- The tree view with inverse balance and posssibility to hide/show some field -->
    <record model="ir.ui.view" id="agepoly_mis_budget_by_account_item_tree_view">
        <field name="name">
            agepoly.mis.budget.by.account.item.tree (in mis_builder_budget)
        </field>
        <field name="model">mis.budget.by.account.item</field>
        <field name="mode">primary</field> 
        <field name="arch" type="xml">
            <tree editable="bottom">
                <field name="budget_id" invisible="1" />
                <field name="budget_date_from" invisible="1" />
                <field name="budget_date_to" invisible="1" />
                <field name="name" />
                <field name="account_id" />
                <field
                    name="analytic_account_id"
                    groups="analytic.group_analytic_accounting"
                />
                <field name="date_range_id" />
                <field name="date_from" optional="show"/>
                <field name="date_to" optional="show"/>
                <field name="debit" sum="Total Debit"/>
                <field name="credit" sum="Total Credit"/>
                <field name="inverse_balance" decoration-bf="1" sum="Total (I) Balance"/>
                <field
                    name="analytic_tag_ids"
                    widget="many2many_tags"
                    groups="analytic.group_analytic_accounting"
                    optional="hide"
                />
            </tree>
        </field>
    </record>
    <!-- We define the global view for easy accounting -->
    <record model="ir.actions.act_window" id="agepoly_mis_budget_by_account_item_my_budget">
        <field name="name">My budget</field>
        <field name="view_id" ref="agepoly_mis_budget_by_account_item_tree_view"/>
        <field name="res_model">mis.budget.by.account.item</field>
        <field name="view_mode">tree,form,pivot,graph</field>
        <field name="domain" eval="[('budget_id', '=', ref('agepoly_global_budget'))]"/>
        <field name="context" eval="
            {
                'default_budget_id': ref('agepoly_global_budget'), 
                'search_default_group_by_analytic_group': True, 
                'search_default_group_by_analytic_account': True,
                'search_default_group_by_date_range': True
            }
        "/>
    </record>
</odoo>